#ifndef DMD_H_ACTION_QUEUE
#define DMD_H_ACTION_QUEUE
/*
	action_queue: workqueue for some worker thread

	part of DerMixD
	(c)2007/8 Thomas Orgis, licensed under GPLv2

	Well, you push action items into the queue at one end, and the worker at the other end pulls them.
*/

#include "action.hxx"
#include <pthread.h>

class action_queue
{
	private:
	// A volatile queue gives a nice bulk of C++ blurp from g++ ... guess it's not needed or possible, then...
	// Also volatile actions don't work as this blows up the contained containers.
	// What's the deal with STL and volatile for threading?
	queue<action*> q;
	pthread_mutex_t lock;
	sem_t sem;

	public:
	size_t fill;
	action_queue();
	~action_queue();
	void    push(action *act);
	action* pull();
};

#endif
