#ifndef DMD_H_COMM_DATA
#define DMD_H_COMM_DATA

/*
	comm_data: simple return value/error back transport with semaphore for notifying initiator of action
	
	part of DerMixD
	(c)2004/5 Thomas Orgis, licensed under GPLv2
*/

#include "tstring.hxx"

class comm_data
{
	private:
	bool mysem;
	
	public:
	sem_t * waitress;
	volatile unsigned char errcode;
	string errtext;
	volatile double retval;
	volatile unsigned long int retval_ulong;
	volatile unsigned long int retval_ulong2;
	vector<tstring*> retlines;
	pthread_t * thread;
	
	comm_data();
	comm_data(sem_t *s); //an already existing and initialized semaphore
	comm_data(pthread_t * t);
	~comm_data();
	
	void clear(); //clear the communication data (_not_ waitress and thread!)
};

#endif
