#ifndef DMD_H_COMMUNICATOR_ACTIONS
#define DMD_H_COMMUNICATOR_ACTIONS

/*
	communicator_actions: the world of socketeer/mixer actions
	
	part of DerMixD
	(c)2006 Thomas Orgis, licensed under GPLv2
	
	see the .cxx file for more info
*/

#include "action.hxx"

extern const action_def in_start;
extern const action_def out_start;
extern const action_def in_script;
extern const action_def in_nscript;
extern const action_def external_api[];

//I'll see if these are a good idea
extern const action_def in_notify; 
extern const action_def out_notify; 
extern const action_def notify; 

#define SOCK_LOCAL ACT_CUSTOM1 //local handling
#define SOCK_NOTIFY ACT_CUSTOM2 //notify action to follow
#define SOCK_POST ACT_CUSTOM3 //postprocessing needed
#define SOCK_IN ACT_CUSTOM4 //it's an outaction
#define SOCK_OUT ACT_CUSTOM5 //it's an inaction
#define SOCK_EXT ACT_CUSTOM6 //response to socket is done externally
#define SOCK_ANS ACT_CUSTOM7 //construct special answer
#define SOCK_PATH ACT_CUSTOM8 // last argument is a file path that should be adjusted by socketeer
//numerical action ids

#define NOTIFY 1

//input

#define IN_PAUSE 2
//#define IN_PLAY 3 
#define IN_LOAD 4 
#define IN_STOP 5 
#define IN_START 6
#define IN_SEEK 20 //absolute seek
#define IN_RSEEK 21 //relative seek
#define IN_BIND 22 //bind <input> <output>
#define IN_UNBIND 23 //unbind <input> <output>
#define IN_VOLUME 24
#define IN_BASS 25
#define IN_MID 26
#define IN_TREBLE 27
#define IN_SPEED 28
#define IN_PITCH 40
#define IN_EQ 29
#define IN_FOLLOW 30
#define IN_NOFOLLOW 31
//assume succes for now
#define NOTIFY_IN_LOAD 32
#define NOTIFY_IN_SEEK 33
#define IN_WATCH 34
#define IN_UNWATCH 35
#define IN_SCRIPT 36
#define IN_CLEARSCRIPT 37
#define IN_SHOWSCRIPT 38
//#define IN_PLAY 38
#define IN_VOL 39
#define IN_LENGTH 41
#define IN_BUFFER 42
#define IN_INLOAD 43
#define IN_SCAN 44
#define IN_PREREAD 45
//the border: 100

//output

#define OUT_PAUSE 153 //pausing output with leaving all files open
#define OUT_START 154 //make it PLAYING
#define OUT_LOAD 155 //load a location (sound card, encoder stream, file); create device
#define OUT_STOP 156 //stop writing audio, close file (subsequent start reopens file and possibly overwrites when no load is in between)
#define NOTIFY_OUT_LOAD 157
#define OUT_SCRIPT 158
#define OUT_CLEARSCRIPT 159
//#define OUT_PLAY 160
//the big border: 200

//general

#define SLEEP 201 //of the whole process...
#define QUIT 202 //obvious
#define ADD_IN 203
#define ADD_OUT 204
#define REM_IN 205
#define REM_OUT 206
#define GETSTAT 207
#define FULLSTAT 210
#define CLOSE 209 //close socketeer thread 
#define TIME_SCRIPT 210
#define TIME_CLEARSCRIPT 211
#define SAY 212
#define THREADSTAT 213
#define LS 214
#define PWD 215
#define CD 216
//to be handled directly by socketeer

#define COMM_LOCAL 230
#define ID 246
#define FADEOUT 247 //this will never become a real action
#define HELP 248
#define SHOWAPI 249
#define SPY 250
#define UNSPY 251
#define SHOWID 252
#define SHOWPEERS 231
#define ADDPEER 232
#define REMPEER 233
#define PEER 234

//action errors

#include "action_errors.hxx"

#endif
