#ifndef DMD_H_DEBUG
#define DMD_H_DEBUG

#ifdef debug
#undef debug
#endif
#ifdef sdebug
#undef sdebug
#endif
#ifdef warning
#undef warning
#endif
#ifdef error
#undef error
#endif
#ifdef serror
#undef serror
#endif

// extreme debugging
#ifdef XDEBUG
#define DEBUG
#endif

#ifdef DMD_DBUG
#define DEBUG
#endif

#ifdef DEBUG
#undef NDEBUG
#include <stdio.h>
#define sdebug(s) fprintf(stderr, "[" __FILE__ ":%i] debug: %s\n", __LINE__, s)
#define debug(s, ...) fprintf(stderr, "[" __FILE__ ":%i] debug: " s "\n", __LINE__, __VA_ARGS__)
#else
#define NDEBUG
#define debug(s, ...) do {} while(0)
#define sdebug(s) do {} while(0)
#endif

#ifdef XDEBUG
#define xdebug(s, ...) debug(s, __VA_ARGS__)
#define sxdebug(s) sdebug(s)
#else
#define xdebug(s, ...) do {} while(0)
#define sxdebug(s) do {} while(0)
#endif

#ifdef DEBUG_MEM
#define MEMDEBUG
#endif

#ifdef MEMDEBUG
#define construct(s) fprintf(stderr, "_C %p %s\n", this, s)
#define destbegin(s) fprintf(stderr, "_D %p %s\n", this, s)
#define destend(s) fprintf(stderr, "_F %p %s\n", this, s)
#define destruct(s) destbegin(s); destend(s)
#else
#define construct(s) do {} while(0)
#define destbegin(s) do {} while(0)
#define destend(s) do {} while(0)
#define destruct(s) do {} while(0)
#endif

#define warning(s, ...) fprintf(stderr, "[" __FILE__ ":%i] warning: " s "\n", __LINE__, __VA_ARGS__)
#define swarning(s) fprintf(stderr, "[" __FILE__ ":%i] warning: %s\n", __LINE__, s)
#define error(s, ...) fprintf(stderr, "[" __FILE__ ":%i] error: " s "\n", __LINE__, __VA_ARGS__)
#define serror(s) fprintf(stderr, "[" __FILE__ ":%i] error: %s\n", __LINE__, s)

#define note(s, ...) fprintf(stderr, s "\n", __VA_ARGS__)
#define snote(s) fprintf(stderr, "%s\n", s)

#endif
