#ifndef DMD_H_IN_RAW_S16
#define DMD_H_IN_RAW_S16

/*
	in_raw_s16: RAW Stereo 16bit (no thoughts about byte order) input device
	
	part of DerMixD
	(c)2004-7 Thomas Orgis, licensed under GPLv2
	
	This reads from files with RAW data (no audio devices, though If you have a driver that offers a simple device file to read from...).
*/

class raw_s16_input: public input_device
{
	protected:
		ifstream file;
	public:
		static const string t;
		raw_s16_input(input_data* chd);
		~raw_s16_input();
		volatile bool on_line;
		volatile bool im_ready;
		
		int load(comm_data* cd, const string& filename); //load the file stated in chdata, respond to socket
		int seek(comm_data* cd, double position); //try to seek to data->position, set it to really achieved value, respond to socket
		void scan_length(comm_data* cd){ done_scan_length(cd); };
		int sampleseek(comm_data* cd, unsigned long position);
		int play(unsigned int n_samples); //fill buffer with mixer data format (after pitch / resampling)
		int set_eq(comm_data* cd);
		bool online(){ return on_line; }; //loaded and ready to do sth.
		bool ready(){ return im_ready; }; //ready to play sth
};

#endif
