#ifndef DMD_H_IN_SINE
#define DMD_H_IN_SINE

/*
	in_sine: sine_input device
	
	just a simple tone generator, one channel, one sine wave
	it uses a kindof URL syntax to fake a filename:
	loading of sine://1000@48000 results in a 1000Hz sine wave sampled at 48kHz,
	loading of sine://1000 results in 1000Hz wave sampled at whatever the current sampe rate is
	
	part of DerMixD
	(c)2006-7 Thomas Orgis, licensed under GPLv2
*/

class sine_input: public input_device 
{
	protected:
		int frequency;
		local_audio_buffer table;
		bool build_table();
		
	public:
		static const string t;
		sine_input(input_data* ind);
		~sine_input();
		int load(comm_data* cd, const string& filename); //load the file stated in chdata, respond to socket
		int seek(comm_data* cd, double position); //try to seek to data->position, set it to really achieved value, respond to socket
		void scan_length(comm_data* cd){ no_scan_length(cd); };
		int sampleseek(comm_data* cd, unsigned long position);
		int play(unsigned int n_samples); //fill buffer with mixer data format (after pitch / resampling)
		int set_eq(comm_data* cd);
		bool online(){ return true; };
		bool ready(){ return true; };
};

#endif
