#ifndef DMD_H_IN_SNDFILE
#define DMD_H_IN_SNDFILE
/*
	in_sndfile: input of files handled by libsndfile
	
	part of DerMixD
	(c)2007 Thomas Orgis, licensed under GPLv2
*/

#include "input.hxx"
#include <sndfile.h>

class snd_file: public input_file
{
	private:
	SF_INFO info;
	SNDFILE* file;

	public:
	snd_file();
	~snd_file();
	bool do_read(audio_buffer *buffer, unsigned int wanted_samples);
	bool do_open(input_data *data);
	void do_close();
	bool do_seek(input_data *data);
	bool do_length(input_data *data){ return true; }
};

class sndfile_input: public input_device 
{
	private:
	snd_file sf;

	public:
	static const string t;
	sndfile_input(input_data* ind);
	~sndfile_input();
};

#endif
