#ifndef DMD_H_IN_vorbisfile
#define DMD_H_IN_vorbisfile

/*
	in_vorbisfile: vorbisfile input device (OGG Vorbis files)

	initially written by Sven Oliver Moll

	part of DerMixD
	(c)2007 Sven Oliver Moll and Thomas Orgis, licensed under GPLv2
*/

#include <vorbis/vorbisfile.h>
#include "input.hxx"

class vorbis_file: public input_file
{
private:
	bool opened;
	FILE *file;
	OggVorbis_File handle;
public:

	vorbis_file();
	~vorbis_file();
	bool do_read(audio_buffer *buffer, unsigned int wanted_samples);
	bool do_open(input_data *data);
	void do_close();
	bool do_seek(input_data *data);
	bool do_length(input_data *data){ return true; };
};

class vorbisfile_input: public input_device 
{
private:
	vorbis_file vf;
public:
	static const string t;
	vorbisfile_input(input_data* ind);
	~vorbisfile_input();
};

#endif
