#ifndef DMD_H_MAIN_PARM
#define DMD_H_MAIN_PARM

/*
	main_parm.hxx: pseudo-header for inclusion into param_init() to define the parameters in the main group
	
	part of DerMixD
	(c)2005 Thomas Orgis, licensed under GPLv2
*/

define("main", "tcp",  "yes", "listen on a TCP port");
define("main", "unix", "no", "listen on UNIX domain socket");
define("main", "socket", "/dev/shm/dermixd.socket", "UNIX domain socket path");
define("main", "port", "8888", "specify the TCP port to use");

#ifndef DEFAULT_BUFFER_SAMPLES
	#ifdef OUT_MME
		//my XP1000 does easily stutter with (just) double buffering
		#define DEFAULT_BUFFER_SAMPLES "4096"
	#else
		//bit more responsive default for Linux... just enough for my 366MHz PII laptop
		#define DEFAULT_BUFFER_SAMPLES "2048"
	#endif
#endif

define("main", "buffer", DEFAULT_BUFFER_SAMPLES, "mixer buffer size in samples");
define("main", "audio_rate", "44100", "mixer and output sample rate");
define("main", "channels", "2", "channels for mixer and all outputs (1 for mono or 2 for stereo)");
define("main", "output", "/dev/null", "in daemon mode stdout/err get redirected to that file");

#ifdef OUT_ALSA
	#define DEFOUT "alsa"
	#define DEFOFILE "default"
#else
	#ifdef OUT_OSS
		#define DEFOUT "oss"
		#define DEFOFILE "/dev/dsp"
	#else
		#ifdef OUT_MME
			#define DEFOUT "mme"
			#define DEFOFILE "nothing special"
		#else
			#define DEFOUT "dummy"
			#define DEFOFILE "I don't care!"
		#endif
	#endif
#endif

define("main", "default_output", DEFOUT, "default output device class to use in standard setup");
define("main", "default_outfile", DEFOFILE, "default file for default output...");

#endif
