#ifndef DMD_H_MIXER_TOOLS
#define DMD_H_MIXER_TOOLS

/*
	mixer_tools: tools for mixer
	
	part of DerMixD
	(c)2004/5 Thomas Orgis, licensed under GPLv2
	
	Most important is the audio data gathering: Reading of file parameters from .audiodata file (could I change that ending to something shorter?) or just some guessing by file name.
*/

class audiodata
{
	public:
	
	bool reliable;
	bool exists;
	string type;
	audio_format format;
	unsigned long length;
	double rva;
	vector<unsigned long int> specials;
	string problem;

	audiodata()
	{
		#ifdef DEBUG_MEM
		cout << "create audiodata" << endl;
		#endif
		type = "";
		rva = 0;
		format.rate = 44100;
		format.channels = 2;
		length = 0;
		reliable = false;
		exists = false;
	};
	~audiodata()
	{
		#ifdef DEBUG_MEM
		cout << "destruct audiodata" << endl;
		#endif
	};

	void parse(const string &t);
};

audiodata* get_audiodata(string sname, string type = "auto");
string stringstatus(signed char status);
string compatstatus(signed char status);

#endif
