#ifndef DMD_H_OUT_DUMMY
#define DMD_H_OUT_DUMMY

/*
	out_dummy: dummy output device
	
	part of DerMixD
	(c)2004/5 Thomas Orgis, licensed under GPLv2
	
	This serves as a testing facility of the framework and also as a good starting point for new output device implementations.
*/

//custom data structure for the writer thread
typedef struct dummy_writerextra
{
	float time_factor;
	volatile audio_format* format;
} dummy_writerextra;

//the class
class dummy_output: public output_device
{
	private:
		dummy_writerextra wextra;
		bool special_init();
		void special_exit();
		bool special_activate();
		void special_deactivate();
		void special_pause();
		
	public:
		static const string t;
		dummy_output(output_data* odi, unsigned int bufsize);
		~dummy_output();
		string type(){ return t; };
};

#endif
