#ifndef DMD_H_OUT_MME
#define DMD_H_OUT_MME

/*
	out_mme: mme output device (for MME on Tru64 Unix)
	
	part of DerMixD
	(c)2005 Thomas Orgis, licensed under GPLv2
*/

//need the types...
#include <mme/mme_api.h>

typedef struct mme_writerextra
{
	//better be volatile??
	HWAVE* wave_device;
	WAVEHDR* wave_header;
} mme_writerextra;

class mme_output: public output_device
{
	private:
		HWAVE wave_device;
		PCMWAVEFORMAT* wave_format;
		WAVEHDR* wave_header;
		mme_writerextra wextra;
		
		bool special_init();
		void special_exit();
		bool special_activate();
		void special_deactivate();
		void special_pause();
		
	public:
		static const string t;
		mme_output(output_data* odi, unsigned int bufsize);
		~mme_output();
		string type(){ return t; };
		bool resize_buffer(unsigned int s); //need special handling of shared buffers
};

#endif
