#ifndef DMD_H_OUT_TEXT
#define DMD_H_OUT_TEXT

/*
	out_text: text output device
	
	part of DerMixD
	(c)2005 Thomas Orgis, licensed under GPLv2
	
	This is a device for debugging and maybe other weird interests.
	It writes the output into a ascii text file - lines with TAB-separated numbers.
	Nice to easily plot the result of mixing; not nice for storage;-)
*/

//custom data structure for the writer thread
typedef struct text_writerextra
{
	ofstream file;
} text_writerextra;

//the class
class text_output: public output_device
{
	private:
		text_writerextra wextra;
		bool special_init();
		void special_exit();
		bool special_activate();
		void special_deactivate();
		void special_pause();
		
	public:
		static const string t;
		text_output(output_data* odi, unsigned int bufsize);
		~text_output();
		string type(){ return t; };
};

#endif
