#define DEBUG_FIFO2

#include "../common.h"

#include "../audio_buffer.h"
#include "../audio_fifo.h"


void print_buffer(audio_buffer* abo)
{
	for(unsigned int t = 0; t < abo->size; ++t) cout << t << ":(" << abo->ptr[2*t] << "|" << abo->ptr[2*t+1] << ")" << endl; 
}


int main()
{
	volatile bool endA = false, endB = false;
	unsigned int wsam = 0;
	cout << "The buffer test. Concentrating on audio_fifo since the underlying audio_buffer is apparently stable in use...\n";
	audio_fifo afi(STDIN_FILENO, 2, 9, &endA, &endB);
	audio_buffer abu(2,4);
	cout << "testing scans...\n";
	
	afi.ptr[0] = 0;	
	afi.ptr[1] = 0;	
	afi.ptr[2] = 0;	
	afi.ptr[3] = 0;	
	afi.ptr[4] = 0;	
	afi.ptr[5] = 0;	
	afi.ptr[6] = 0;	
	afi.ptr[7] = 123;	
	afi.ptr[8] = -1;	
	afi.ptr[9] = 0;	
	afi.ptr[10] = 0;	
	afi.ptr[11] = 0;	
	afi.ptr[12] = 3;	
	afi.ptr[13] = 0;	
	afi.ptr[14] = 0;	
	afi.ptr[15] = 0;	
	afi.ptr[16] = 0;	
	afi.ptr[17] = 0;	
	
	afi.fill = 9;
	print_buffer(&afi);
	afi.status();
	afi.startzeroscan();	
	afi.status();
	afi.endzeroscan();	
	afi.status();
	afi.clear();

	afi.ptr[0] = 0;	
	afi.ptr[1] = 0;	
	afi.ptr[2] = 0;	
	afi.ptr[3] = 1;	
	afi.ptr[4] = 0;	
	afi.ptr[5] = 0;	
	afi.ptr[6] = 0;	
	afi.ptr[7] = 123;	
	afi.ptr[8] = -1;	
	afi.ptr[9] = 0;	
	afi.ptr[10] = 0;	
	afi.ptr[11] = 0;	
	afi.ptr[12] = 3;	
	afi.ptr[13] = 0;	
	afi.ptr[14] = 0;	
	afi.ptr[15] = 0;	
	afi.ptr[16] = 0;	
	afi.ptr[17] = 0;	
	
	//now the readerpos should be at 4.. setting fill to 8 for having a wrap
	afi.fill = 8;
	afi.readerpos = 4;
	print_buffer(&afi);
	afi.status();
	afi.endzeroscan();	
	afi.status();

	afi.clear();

	afi.ptr[0] = 0;	
	afi.ptr[1] = 0;	
	afi.ptr[2] = 0;	
	afi.ptr[3] = 0;	
	afi.ptr[4] = 0;	
	afi.ptr[5] = 0;	
	afi.ptr[6] = 0;	
	afi.ptr[7] = 123;	
	afi.ptr[8] = -1;	
	afi.ptr[9] = 0;	
	afi.ptr[10] = 0;	
	afi.ptr[11] = 0;	
	afi.ptr[12] = 3;	
	afi.ptr[13] = 0;	
	afi.ptr[14] = 0;	
	afi.ptr[15] = 0;	
	afi.ptr[16] = 0;	
	afi.ptr[17] = 0;	
	

	//now the readerpos should be at 4.. setting fill to 8 for having a wrap
	afi.fill = 8;
	afi.readerpos = 4;
	print_buffer(&afi);
	afi.status();
	afi.endzeroscan();	
	afi.status();

	cout << "I've set up a fifo on STDIN. You are the decoder now." << endl;	
	afi.status();
	afi.refill();
	wsam = 4;
	afi.gimme(abu, wsam);
	print_buffer(&abu);
	afi.status();	
	afi.refill();
	afi.status();
	if(wsam == 0) { wsam = 4; abu.fill = 0; }
 	afi.gimme(abu, wsam);
	print_buffer(&abu);
	afi.status();	
	afi.refill();
	afi.status();


	if(wsam == 0) { wsam = 4; abu.fill = 0; }
	afi.gimme(abu, wsam);
	print_buffer(&abu);
	afi.status();	
	afi.refill();
	afi.status();

	if(wsam == 0) { wsam = 4; abu.fill = 0; }
	afi.gimme(abu, wsam);
	print_buffer(&abu);
	afi.status();	
	afi.refill();
	afi.status();

	if(wsam == 0) { wsam = 4; abu.fill = 0; }
	afi.gimme(abu, wsam);
	print_buffer(&abu);
	afi.status();	
	afi.refill();
	afi.status();

	endA = true;
	cout << "end bool A is true now\n";
	if(wsam == 0) { wsam = 4; abu.fill = 0; }
	afi.gimme(abu, wsam);
	afi.status();	
	afi.refill();
	afi.status();
}

