#ifndef H_DMD_THREAD_CONTAINER
#define H_DMD_THREAD_CONTAINER
/*
	thread_container: something that contains threads

	part of DerMixD
	(c)2007-8 Thomas Orgis, licensed under GPLv2

	This class currently only exists to ease gathering of thread info.
	I want to know who's there to explain the thread/process count.
*/

#include "common.hxx"
#include "debug.hxx"
#include "tstring.hxx"

class thread_data
{
	public:
#ifdef LINUX
	volatile pid_t pid;
	volatile int   priority;
#endif
	thread_data()
	{
#ifdef LINUX
		pid = -1;
		priority = 0;
#endif
	};
	virtual ~thread_data(){};
	void thread_workout(int pri_offset); // Only does something on linux for now.
};

class threadspec
{
	public:
	pthread_t id;
	thread_data *td;
	string text;
	threadspec();
	threadspec(const pthread_t tid, const string ttext, thread_data *td = NULL);
	~threadspec();
	void add_info(vector<tstring*> &tl);
};

class thread_container
{
	public:
	vector<threadspec*> threads;
	thread_container *sub_thread_container;
	thread_container();
	virtual ~thread_container();
	// returns thread count, appends descriptions
	virtual size_t thread_info(vector<tstring*> &tl);
	void add_thread(const pthread_t id, const string text, thread_data *td = NULL);
};

#endif
